#ifndef __IO_H__
#define __IO_H__

#include <stdint.h>

// FRW SPI:
#define OP_SPI_SELECT        0x22
#define OP_SPI_UNSELECT      0x33
#define OP_SPI_SEND          0x44

#define OP_CE_SET            0x55
#define OP_CE_CLR            0x66

// FRW Clear command:
#define OP_FW_SWITCH         0xCB
#define OP_FW_CLEAR          0xCC
#define OP_FW_WRITE_RAM      0xCD
#define OP_FW_WRITE_BLOCK    0xCE
#define OP_FW_GET_HW         0xCF

// ..
#define MEM_LOG_OFFSET       0x200

// ..
#define FW_CLEAR_VECTOR      { 0x12, 0x44, 0x54, 0x77, 0xA4, 0xE3, 0x9A, 0x45 }
#define FW_KILL_VECTOR       { 0xAE, 0x9C, 0x4F, 0xD2, 0x75, 0xAA, 0x38, 0xB6 }

typedef union 
{
	struct 
	{
		uint8_t bOperation;
		uint8_t bDevAddr;
		uint8_t bAddr;
		uint8_t bLen;
		uint8_t abData[];
	} pc2dev;
	
	struct 
	{
		uint8_t bRetStatus;
		uint8_t bRes1;
		uint8_t bRes2;
		uint8_t bLen;
		uint8_t abData[];
	} dev2pc;

	uint8_t abBuffer[64];
} io_data_t;

#endif // __IO_H__
